package org.loom.addons.recaptcha;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.net.URISyntaxException;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.protocol.HTTP;

/**
 * {@link RecaptchaService} implementation to use {@link URLConnection} 
 * @author icoloma
 */
public class DefaultRecaptchaServiceImpl extends AbstractRecaptchaService {

	@Override
	protected byte[] getValidationResult(Map<String, String> params) {
		try {
			// set parameters
			HttpPost post = new HttpPost(VERIFY_URL.toURI());
			List<NameValuePair> nvps = new ArrayList<NameValuePair>(); 
			for (Map.Entry<String, String> entry : params.entrySet()) {
				nvps.add(new BasicNameValuePair(entry.getKey(), entry.getValue()));
			}
			post.setEntity(new UrlEncodedFormEntity(nvps, HTTP.UTF_8)); 

			// execute query
			HttpClient client = new DefaultHttpClient();
			ByteArrayOutputStream bos = new ByteArrayOutputStream();
			client.execute(post).getEntity().writeTo(bos);
			return bos.toByteArray();
		} catch (URISyntaxException e) {
			throw new RuntimeException(e);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}

}
